com.sun.grid.jgdi.rmi

## Interface JGDIRemoteBase

- All Superinterfaces:
    java.rmi.Remote
  All Known Subinterfaces:
    JGDIRemote
  All Known Implementing Classes:
    JGDIRemoteBaseImpl, JGDIRemoteCache, JGDIRemoteCacheBase, JGDIRemoteImpl

      public interface JGDIRemoteBase
      extends java.rmi.Remote

  Base interface for the JGDIRemote.
  TODO:
    optional ??

    add qquota functions

    , optional ??

    add qstat functions

    , optional ??

    add qhost functions

    , optional ??

    add qmod functions

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cleanQueues(java.lang.String[] queues)` Cleans queue from jobs which haven't been reaped.
    `void` | `clearJobs(java.lang.String[] jobs, boolean force)` Clears the error state of the specified jobs(s).
    `void` | `clearQueues(java.lang.String[] queues, boolean force)` Clears the error state of the specified queues(s).
    `void` | `clearShareTreeUsage()` Clears all user and project usage from the sharetree.
    `void` | `close()` Close the `JGDI` object.
    `void` | `disableQueues(java.lang.String[] queues, boolean force)` Disable queue(s), i.e.
    `void` | `enableQueues(java.lang.String[] queues, boolean force)` Enable queue(s).
    `QHostResult` | `execQHost(QHostOptions options)` Get summary information about cluster hosts.
    `java.lang.String` | `getActQMaster()` Get the hostname of the current qmaster
    `java.lang.String` | `getAdminUser()` Get the admin user
    `java.util.List` | `getClusterQueueSummary(ClusterQueueSummaryOptions options)` Get summary information about cluster queues.
    `QQuotaResult` | `getQQuota(QQuotaOptions options)` Get the limit information.
    `QueueInstanceSummaryResult` | `getQueueInstanceSummary(QueueInstanceSummaryOptions options)` Get summary information abouter queue instances.
    `java.util.List` | `getRealExecHostList()` Get the list of real exec hosts (excludes "template" and "global").
    `java.lang.String` | `getSchedulerHost()` Return the host where the Sun™ Grid Engine scheduler sge_schedd(8) is active or null otherwise
    `java.lang.String` | `getSGECell()` Get the cell of the grid engine
    `java.io.File` | `getSGERoot()` Get the root directory of the grid engine installation
    `void` | `killAllEventClients()` Used to shutdown event clients all registered at qmaster(8).
    `void` | `killAllExecds(boolean terminateJobs)` Send all execution hosts a kill signal.
    `void` | `killEventClients(int[] ids)` Used to shutdown event clients registered at qmaster(8), except special clients like the sge_schedd(8)
    `void` | `killExecd(java.lang.String[] hosts, boolean terminateJobs)` Send some execution hosts a kill signal.
    `void` | `killMaster()` Send the qmaster a kill signal.
    `void` | `killScheduler()` Send the schedduler a kill signal.
    `void` | `rescheduleJobs(java.lang.String[] jobs, boolean force)` If applied to running jobs, reschedules the jobs.
    `void` | `rescheduleQueues(java.lang.String[] queues, boolean force)` Reschedules all jobs currently running in the queue(s).
    `void` | `suspendJobs(java.lang.String[] jobs, boolean force)` Suspends job(s).
    `void` | `suspendQueues(java.lang.String[] queues, boolean force)` Suspend the queues and any jobs which might be active.
    `void` | `triggerSchedulerMonitoring()` The Sun™ Grid Engine scheduler sge_schedd(8) is forced to print trace messages of its next scheduling run to the file <sge_root>/<cell>/common/schedd_runlog.
    `void` | `unsuspendJobs(java.lang.String[] jobs, boolean force)` Unsuspends the job(s).
    `void` | `unsuspendQueues(java.lang.String[] queues, boolean force)` Unsuspends the queues and any jobs which might be active.

- - ### Method Detail

    - #### getAdminUser

          java.lang.String getAdminUser()
                                 throws java.rmi.RemoteException

      Get the admin user
      Returns:
        the admin user
      Throws:
        `java.rmi.RemoteException` - on any error on the GDI layer

    - #### getSGERoot

          java.io.File getSGERoot()
                           throws java.rmi.RemoteException

      Get the root directory of the grid engine installation
      Returns:
        root directory of the gridengine installation
      Throws:
        `java.rmi.RemoteException`

    - #### getSGECell

          java.lang.String getSGECell()
                               throws java.rmi.RemoteException

      Get the cell of the grid engine
      Returns:
        the cell of the grid engine
      Throws:
        `java.rmi.RemoteException`

    - #### getActQMaster

          java.lang.String getActQMaster()
                                  throws java.rmi.RemoteException

      Get the hostname of the current qmaster
      Returns:
        the hostname of the current qmaster
      Throws:
        `java.rmi.RemoteException` - on any error on the GDI layer

    - #### close

          void close()
              throws java.rmi.RemoteException

      Close the `JGDI` object. After calling this method the `JGDI` is not longer useable.
      Throws:
        `java.rmi.RemoteException` - on any error on the GDI layer

    - #### getRealExecHostList

          java.util.List getRealExecHostList()
                                      throws java.rmi.RemoteException

      Get the list of real exec hosts (excludes "template" and "global").
      Returns:
        the list of real exec hosts
      Throws:
        `java.rmi.RemoteException`

    - #### execQHost

          QHostResult execQHost(QHostOptions options)
                         throws java.rmi.RemoteException

      Get summary information about cluster hosts. The CLI equivialent of this method is `qhost` (see man qhost(1)).
      Parameters:
        `options` - host summary options
      Returns:
        the `QHostResult` object which the host summary information
      Throws:
        `java.rmi.RemoteException` - on any error in the GDI layer

    - #### getClusterQueueSummary

          java.util.List getClusterQueueSummary(ClusterQueueSummaryOptions options)
                                         throws java.rmi.RemoteException

      Get summary information about cluster queues. The CLI equivialent of this method is `qstat -g c` (see man qstat(1)).
      Parameters:
        `options` - options the cluster queue summary algorithm
      Throws:
        `java.rmi.RemoteException` - on any error in the GDI layer

    - #### getQueueInstanceSummary

          QueueInstanceSummaryResult getQueueInstanceSummary(QueueInstanceSummaryOptions options)
                                                      throws java.rmi.RemoteException

      Get summary information abouter queue instances. The CLI equivialent of this method is `qstat` (see man qstat(1)).
      Parameters:
        `options` - Options for the queue instance summary algorithm
      Returns:
        the queue instance summary object
      Throws:
        `java.rmi.RemoteException` - on any error in the GDI layer

    - #### getQQuota

          QQuotaResult getQQuota(QQuotaOptions options)
                          throws java.rmi.RemoteException

      Get the limit information. The CLI equivialent of this method is `qquota` (see man qquota(1)).
      Parameters:
        `options` - the options for the qquota algorithm
      Returns:
        list of `QQuotaResult` instances
      Throws:
        `java.rmi.RemoteException`

    - #### clearShareTreeUsage

          void clearShareTreeUsage()
                            throws java.rmi.RemoteException

      Clears all user and project usage from the sharetree. All usage will be initialized back to zero.

      The CLI equivialent for this method is `qconf -clearusage` (see man qconf(1)).

      Throws:
        `java.rmi.RemoteException`

    - #### cleanQueues

          void cleanQueues(java.lang.String[] queues)
                    throws java.rmi.RemoteException

      Cleans queue from jobs which haven't been reaped. Primarily for development purpose. Requires root/manager/operator privileges.

      The CLI equivialent for this method is `qconf -kcq` (see man qconf(1)).

      Parameters:
        `queues` - a wild card queue list
      Throws:
        `java.rmi.RemoteException` - on any error on the GDI layer

    - #### killMaster

          void killMaster()
                   throws java.rmi.RemoteException

      Send the qmaster a kill signal.

      The CLI equivialent for this method is `qconf -km` (see man qconf(1)).

      Throws:
        `java.rmi.RemoteException` - on any error on the GDI layer

    - #### killScheduler

          void killScheduler()
                      throws java.rmi.RemoteException

      Send the schedduler a kill signal.

      The CLI equivialent for this method is `qconf -ks` (see man qconf(1)).

      Throws:
        `java.rmi.RemoteException` - on any error on the GDI layer

    - #### killExecd

          void killExecd(java.lang.String[] hosts,
                         boolean terminateJobs)
                  throws java.rmi.RemoteException

      Send some execution hosts a kill signal.

      The CLI equivialent for this method is `qconf -ke` (see man qconf(1)).

      Parameters:
        `hosts` - a host name list
        `terminateJobs` - if true, all jobs running on the execution hosts are aborted prior to termination of the corresponding sge_execd(8).
      Throws:
        `java.rmi.RemoteException` - on any error on the GDI layer

    - #### killAllExecds

          void killAllExecds(boolean terminateJobs)
                      throws java.rmi.RemoteException

      Send all execution hosts a kill signal.

      The CLI equivialent for this method is `qconf -ke all` (see man qconf(1)).

      Parameters:
        `terminateJobs` - if true, all jobs running on the execution hosts are aborted prior to termination of the corresponding sge_execd(8).
      Throws:
        `java.rmi.RemoteException` - on any error on the GDI layer

    - #### killEventClients

          void killEventClients(int[] ids)
                         throws java.rmi.RemoteException

      Used to shutdown event clients registered at qmaster(8), except special clients like the sge_schedd(8)

      Requires root or manager privilege.

      The CLI equivialent for this method is `qconf -secl` (see man qconf(1)).

      Parameters:
        `ids` - array with the ids of the event clients which should be killed
      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### killAllEventClients

          void killAllEventClients()
                            throws java.rmi.RemoteException

      Used to shutdown event clients all registered at qmaster(8).

      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### triggerSchedulerMonitoring

          void triggerSchedulerMonitoring()
                                   throws java.rmi.RemoteException

      The Sun™ Grid Engine scheduler sge_schedd(8) is forced to print trace messages of its next scheduling run to the file <sge_root>/<cell>/common/schedd_runlog. The messages indicate the reasons for jobs and queues not being selected in that run.

      Requires root or manager privileges.

      The CLI equivialent for this method is `qconf -tsm` (see man qconf(1)).

      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### getSchedulerHost

          java.lang.String getSchedulerHost()
                                     throws java.rmi.RemoteException

      Return the host where the Sun™ Grid Engine scheduler sge_schedd(8) is active or null otherwise

      The CLI equivialent for this method is `qconf -sss` (see man qconf(1)).

      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### enableQueues

          void enableQueues(java.lang.String[] queues,
                            boolean force)
                     throws java.rmi.RemoteException

      Enable queue(s).

      The CLI equivialent for this method is `qmod -e`(see man qmod(1)).``

      Parameters:
        `queues` - a wildcard queue list
        `force` - force the action
      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### disableQueues

          void disableQueues(java.lang.String[] queues,
                             boolean force)
                      throws java.rmi.RemoteException

      Disable queue(s), i.e. no further jobs are dispatched to disabled queues while jobs already executing in these queues are allowed to finish.

      The CLI equivialent for this method is `qmod -d`(see man qmod(1)).``

      Parameters:
        `queues` - a wildcard queue list
        `force` - force the action
      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### suspendQueues

          void suspendQueues(java.lang.String[] queues,
                             boolean force)
                      throws java.rmi.RemoteException

      Suspend the queues and any jobs which might be active.

      The CLI equivialent for this method is qmod -sq (see man qmod(1)).

      Parameters:
        `queues` - a wildcard queue list
        `force` - force the action
      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### suspendJobs

          void suspendJobs(java.lang.String[] jobs,
                           boolean force)
                    throws java.rmi.RemoteException

      Suspends job(s). If a job is both suspended explicitly and via suspension of its queue, a following unsuspend of the queue will not release the suspension state on the job.

      The CLI equivialent for this method is `qmod -sj` (see man qmod(1)).

      Parameters:
        `jobs` - a wildcard job list
        `force` - force the action
      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### unsuspendQueues

          void unsuspendQueues(java.lang.String[] queues,
                               boolean force)
                        throws java.rmi.RemoteException

      Unsuspends the queues and any jobs which might be active.

      The CLI equivialent for this method is `qmod -usq` (see man qmod(1)).

      Parameters:
        `queues` - a wildcard queue list
        `force` - force the action
      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### unsuspendJobs

          void unsuspendJobs(java.lang.String[] jobs,
                             boolean force)
                      throws java.rmi.RemoteException

      Unsuspends the job(s). If a job is both suspended explicitly and via suspension of its queue, a following unsuspend of the queue will not release the suspension state on the job.

      The CLI equivialent for this method is `qmod -usj` (see man qmod(1)).

      Parameters:
        `jobs` - a wildcard queue list
        `force` - force the action
      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### clearQueues

          void clearQueues(java.lang.String[] queues,
                           boolean force)
                    throws java.rmi.RemoteException

      Clears the error state of the specified queues(s).

      The CLI equivialent for this method is `qmod -cq`(see man qmod(1)).``

      Parameters:
        `queues` - a wildcard queue list
        `force` -

        Force the modification action for the queue despite the apparent current state of the queue.

      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### clearJobs

          void clearJobs(java.lang.String[] jobs,
                         boolean force)
                  throws java.rmi.RemoteException

      Clears the error state of the specified jobs(s).

      The CLI equivialent for this method is qmod -cj (see man qmod(1)).

      Parameters:
        `jobs` - a wildcard job list
        `force` - Force the modification action for the job(s)
      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### rescheduleQueues

          void rescheduleQueues(java.lang.String[] queues,
                                boolean force)
                         throws java.rmi.RemoteException

      Reschedules all jobs currently running in the queue(s). Requires root or manager privileges.

      The CLI equivialent for this method is `qmod -r` (see man qmod(1)).

      Parameters:
        `queues` - a wildcard queue list
        `force` - Force the modification action for the queue despite the apparent current state of the queue.
      Throws:
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

    - #### rescheduleJobs

          void rescheduleJobs(java.lang.String[] jobs,
                              boolean force)
                       throws java.rmi.RemoteException

      If applied to running jobs, reschedules the jobs. Requires root or manager privileges.

      The CLI equivialent for this method is `qmod -r` (see man qmod(1)).

      Parameters:
        `jobs` - a wildcard job range list
        `force` - Force the modification action for the job(s)
      Throws:
        `java.rmi.RemoteException`
        `java.rmi.RemoteException` - RemoteException on any error on the GDI level

Copyright © 2007 Sun Microsystems, Inc. All rights reserved.